/// 
// Cybiko Media Player
//
// 03/09/2023: Tidy declarations / initialisations
// 03/09/2023: Replace DEFINE with const
//

#include <cybiko.h>
#include "avi.h"

const long AVIBUFFERSIZE=16000;

/**************************/

void msvc(char *,char *,long, long, long);
int getinput(struct module_t *);

/* - - - */

struct avih aheader;
struct vshdr vheader;
struct vstrf vformat;
struct chk chunk;
struct hdr header;

long swp(long);
int bswp(int);

/**************************/

void avi(char *myfile,struct module_t *ptr_main_module){
	struct FileInput file_input;
	long totf=0,width=0,height=0;
	char *mem,*scr,abort=0;

	mem=(char *)malloc(AVIBUFFERSIZE); /* File Buffer */
	if (mem==0){TRACE("Not Enough Memory (AVI Framebuffer)..");abort=1;}

	/*---------------------------------------*/
		 
	FileInput_ctor(&file_input);

	if( FileInput_open( &file_input, myfile ) && abort==0){
		long stp=0,vframe=0,aframe=0;
		long pos=12;
		long ismov=0;
		
		scr=DisplayGraphics_get_page_ptr(ptr_main_module->m_gfx, 0); 
		memset( scr, 0, 4000 );

		FileInput_seek( &file_input, 32, SEEK_SET );
		Input_read( &file_input, &aheader,56);

		FileInput_seek( &file_input, 104, SEEK_SET );
		Input_read( &file_input, &vheader,52);
				   
		FileInput_seek( &file_input, 112+swp(vheader.size), SEEK_SET );
		Input_read( &file_input, &vformat,20);

		width=swp(aheader.xsize);
		height=swp(aheader.ysize);
		totf=swp(aheader.totf);

		TRACE("W:%ld H:%ld D:%ld F:%ld FS:%ld",width,height,bswp(vformat.depth),totf,FileInput_get_size( &file_input));

		//
		// Main AVI process
		//

		while(vframe<totf){
			FileInput_seek( &file_input, pos, SEEK_SET );
			Input_read( &file_input, &chunk,8);
			Input_read( &file_input, &header,12);
			  
			if (memcmp(header.desc,"movi",4)==0 || ismov==1){
				if (ismov==0){TRACE("--MOVIE--");}
				stp=swp(header.size)+8;
				ismov=1;
			}else{
				TRACE("++NOT MOVIE++");
				stp=swp(chunk.size)+8;
			}

			if (memcmp(header.db,"00dc",4)==0 || memcmp(header.db,"00db",4)==0){
				TRACE("VFRAME %ld (%ld) [%ld]",vframe,pos,swp(header.size));
				vframe++;
				if (swp(header.size)<=AVIBUFFERSIZE){
					Input_read( &file_input, mem,swp(header.size)); 
					
					// Decompress frame	
					if (memcmp(vheader.shand,"msvc",4)==0 || memcmp(vheader.shand,"MSVC",4)==0){
						msvc(mem,scr,width,height,swp(header.size));
					}
				}else{
					FileInput_seek( &file_input,swp(header.size) , SEEK_CUR );
				}
				DisplayGraphics_show(ptr_main_module->m_gfx );
			}

			if (memcmp(header.db,"01wb",4)==0){
				TRACE("AFRAME %ld",aframe);
				aframe++;
			}

			if(getinput(ptr_main_module)==KEY_ESC){break;}

			pos+=stp; 
		}   
		
		TRACE("Finished (VF:%d)\n",vframe);
	}

	FileInput_dtor( &file_input, LEAVE_MEMORY );
	free(mem);


}