/*
Fli Module

Tidy! Make each frame type a function
*/

#include <cybiko.h>

/**************************************/

struct
{
long size;
int magic;
int frames;
int x;
int y;
int depth;
int flags;
int speed;
long next;
long frit;
char expand[102]; 
}fliheader;

struct
{
long size;
int magic;
int chunks;
char expand[8];
}frame;

struct
{
long size;
int type;
}flichunk;

/******************************/

long swp(long);
int bswp(int);
void fplot(char*,long,long,long,char);
int getinput(struct module_t *);

/******************************/
/*      FLI FUNCTIONS		  */
/******************************/

void byterun(char *in,char *out,short x,short y,char *fcol)
{
int cnt=0,scrpos=0,bx,by,ax,sizecnt,f,col,packets;

		for(by=0;by<y;by++)
		{
		packets=in[cnt++];
		ax=0;
			for(bx=0;bx<packets;bx++)
			{
			sizecnt=in[cnt++];

			if (sizecnt>0)
			{
				col=in[cnt];
				if (col<0){col+=256;}
				col=fcol[col];

				for(f=0;f<sizecnt;f++)
				{
				fplot(out,ax,by,160,col);
				ax++;
				}
				cnt++;
			}
			else
			{
				for(f=0;f<-sizecnt;f++)
				{
				col=in[cnt++];
				if (col<0){col+=256;}
				fplot(out,ax,by,160,fcol[col]);				
				ax++;
				}
			}			

			}
		}

}

/*

void linecomp(char *mem,char *scr,short x,short y)
{
long cnt,skip,chng,bx,by,scrpos,f,sizecnt;
int packets,skipcnt;

		skip=(mem[1]<<8)+mem[0];
		chng=(mem[3]<<8)+mem[2];

		cnt=4;

		for(by=skip;by<skip+chng;by++)
		{
			packets=mem[cnt++];

		if (packets!=0)
		{

			scrpos=x*by;
			
			for(bx=0;bx<packets;bx++)
			{
			skipcnt=mem[cnt++];
			sizecnt=mem[cnt++];

			scrpos=scrpos+skipcnt;

			if (sizecnt>0)
			{
				for(f=0;f<sizecnt;f++)
				{
				scr[scrpos++]=mem[cnt++];
				}
			}
			else
			{
				for(f=0;f<-sizecnt;f++)
				{
				scr[scrpos++]=mem[cnt];
				}
				cnt++;
			}			
			}


		}

	}

}

*/

void color256(char *mem)
{
int p,c,cnt;
int packets,skip,chng;
char r,g,b;

packets=(mem[1]<<8)+mem[0];

cnt=2;

for(p=0;p<packets;p++)
{
	skip=mem[cnt++];
	chng=mem[cnt++];

	if (chng==0){chng=256;skip=0;}

	for(c=skip;c<(skip+chng);c++)
	{
	r=mem[cnt++];
	g=mem[cnt++];
	b=mem[cnt++];
	}
}


}

void color24(char *in,char *fcol)
{
int c,off=4,av,r,g,b;

for(c=0;c<256;c++)
{
r=in[off+(c*3)];
g=in[off+(c*3)+1];
b=in[off+(c*3)+2];

if (r<0){r+=256;}
if (g<0){g+=256;}
if (b<0){b+=256;}

av=((r+g+b)/3)>>6;

fcol[c]=3-av;

}

}

void copyblock(char *in,char *out,int x,int y,char *fcol)
{
int i,j,ax,cnt=0;
int a,b,c,d,jpos=0;

ax=(x & 0xfffc)>>2;

for (j=0;j<y;j++)
{
	for (i=0;i<ax;i++)
	{
	a=in[cnt];
	b=in[cnt+1];
	c=in[cnt+2];
	d=in[cnt+3];

	if (a<0){a+=256;}
	if (b<0){b+=256;}
	if (c<0){c+=256;}
	if (d<0){d+=256;}

	a=fcol[a]<<6;
	b=fcol[b]<<4;
	c=fcol[c]<<2;
	d=fcol[d];

	out[jpos+i]=a+b+c+d;	
	cnt+=4;
	}
jpos+=40;
}
}


void delta(char *in,char *out,int x,int y,char *fcol)
{
long cnt=0,ax=0,ay=0;
int lines,packets,i,j,c,ta,tb;
int skip,size,byta,bytb,aw;


lines=((in[1] & 0xff)<<8)+in[0];
cnt=2;

//TRACE("Lines:%ld",lines);

for(j=0;j<lines;j++)
{
ax=0;
ta=in[cnt++];
tb=in[cnt++];

packets=((tb & 0xff)<<8)+ta;

if (packets>0)
{

	for(i=0;i<packets;i++)
	{
	skip=in[cnt++];
	size=in[cnt++];

	if (skip<0){skip+=256;}
	ax+=skip;
	
	if (size>0)
	{
		for(c=0;c<size;c++)
		{
		byta=in[cnt++];
		bytb=in[cnt++];

		if (byta<0){byta+=256;}
		if (bytb<0){bytb+=256;}

		fplot(out,ax+(c+c),ay,160,fcol[byta]);
		fplot(out,ax+(c+c)+1,ay,160,fcol[bytb]);
		}
	
	ax=ax+(size<<1);
	}	
	else
	{
		byta=in[cnt++];
		bytb=in[cnt++];

		if (byta<0){byta+=256;}
		if (bytb<0){bytb+=256;}

		for(c=0;c<-size;c++)
		{
		fplot(out,ax+(c+c),ay,160,fcol[byta]);
		fplot(out,ax+(c+c)+1,ay,160,fcol[bytb]);
		}
	
	ax=ax-(size<<1);
	}

	}


}
else
{
ay-=packets;
}
ay++;

}

//TRACE("Count:%ld",cnt);
}


/******************************/
void fli(char *myfile,struct module_t *ptr_main_module)
{

struct FileInput file_input;

long frames;
int x,y,i,c,showf,abort;
char *mem,*scr,*fcol;

mem=(char *)malloc(16000);
scr=DisplayGraphics_get_page_ptr(ptr_main_module->m_gfx, 0);
fcol=(char *)malloc(260);

if (mem==0){TRACE("Not Enough Memory (Fli_MEM)..");abort=1;}else{memset(mem,0,16000);}
if (fcol==0){TRACE("Not Enough Memory (Fli_FCOL)..");abort=1;}else{memset(fcol,0,260);}
 
 
TRACE("Selected %s",myfile);
     
FileInput_ctor(&file_input);

if( !FileInput_open( &file_input,myfile  ) || abort==1)
{
TRACE("Could not open file.\n");
}
else
{

TRACE("Starting...\n");

memset(scr,0,4000);
Input_read( &file_input, &fliheader,128);

x=bswp(fliheader.x);
y=bswp(fliheader.y);

showf=bswp(fliheader.frames)-1;

for(i=0;i<showf;i++)
{
Input_read( &file_input, &frame,16);


for(c=0;c<bswp(frame.chunks);c++)
{
Input_read( &file_input, &flichunk,6);
Input_read( &file_input, mem,swp(flichunk.size)-6);

	switch (bswp(flichunk.type))
	{
	case 4: 
		TRACE("  4: 256 Colour (PRO) <%ld>",swp(flichunk.size)-6); 
		color24(mem,fcol);
	break;

	case 7: 
		TRACE("  7: Delta (PRO) <%ld>",swp(flichunk.size)-6);
		delta(mem,scr,x,y,fcol);
	break;

	case 11: 
		TRACE(" 11: Colour <%ld>",swp(flichunk.size)-6);
	//	color256(mem,my_screen);
	break;

	case 12: 
		TRACE(" 12: Line Comp <%ld>",swp(flichunk.size)-6);
	//	linecomp(mem,scr,x,y);
	break;

	case 13: 
		TRACE(" 13: Black <%ld>",swp(flichunk.size)-6);
	break;

	case 15: 
		TRACE(" 15: Byte Run <%ld>",swp(flichunk.size)-6);
		byterun(mem,scr,x,y,fcol);
	break;

	case 16: 
		TRACE("16: Copy <%ld>",swp(flichunk.size)-6);
		copyblock(mem,scr,x,y,fcol);
	break;
	
	case 18: TRACE("18: Mini (PRO) <%ld>",swp(flichunk.size)-6); break;
	default: TRACE("%d: Unknown\n",bswp(flichunk.type)); break;
	}

DisplayGraphics_show( ptr_main_module->m_gfx );
}

if(getinput(ptr_main_module)==KEY_ESC){i=showf;}
}

TRACE("Dimensions : %ld x %ld x %ld",x,y,bswp(fliheader.depth));
TRACE("Frames     : %d\n",frames);

FileInput_dtor( &file_input, LEAVE_MEMORY);
}

/*---------------------------------------*/


free(mem);
free(scr);
}





