//
// Book Reader
//
// 23/09/2023 : Late declarations

#include <cybiko.h>

int getinput(struct module_t *);
int ends(char *,char *);

int centerpos(struct module_t *ptr_main_module,char *word){
	int width=Font_string_width( DisplayGraphics_get_font( ptr_main_module->m_gfx),word );
	int pos=(160-width)>>1;	    
	if (pos<0){pos=0;}
	return pos;
}

void textreader(char *myfile,struct module_t *ptr_main_module,long fsize){
	struct FileInput file_input;

	int c=0,width,speed=500,tc=255,fc=0,tmp;
	long bookskip;
	char *word,in=0,ext=0,h=0,paused=0;

	word=(char *)calloc(255,sizeof(char));
	//memset(word,0,255);

	FileInput_ctor(&file_input);

	if( FileInput_open( &file_input,myfile  ) ){

		//If it's a cybiko book skip the header
		if (ends(myfile, ".book" )){
			FileInput_seek( &file_input,8, SEEK_SET );
			Input_read( &file_input, &bookskip,4);
			FileInput_seek( &file_input,bookskip+8, SEEK_SET );
			TRACE("%s is a Cybiko Book, skip = %d ",myfile,bookskip);
		}else{
			TRACE("%s is not a Cybiko Book ",myfile);
		}

		while(c<fsize && ext==0){
			int wc=0;
			int fullstop=0;
			// Clear screen
			TGraph_fill_screen( ptr_main_module->m_gfx, fc);
			
			do{
				Input_read( &file_input, &in,1);
			//	TRACE("%c=%d",in,in);
				if (in>32){word[wc++]=in;}

				if (in=='.'){fullstop=200;}
				if (in==','){fullstop=100;}

				c++;	
			}while(in>32 && c<fsize);
		
			word[wc]=0;

			if (wc>0){	
				// TRACE("word:-%s- %d",word,wc);  
				// Center big		
				int pos=centerpos(ptr_main_module,word);

				//
				TGraph_set_color(ptr_main_module->m_gfx, tc );
				Graphics_set_font( ptr_main_module->m_gfx, cool_bold_font );

				DisplayGraphics_draw_text(ptr_main_module->m_gfx,word, pos, 45 );

				// Info about file
				if (h==0){
					TGraph_set_color(ptr_main_module->m_gfx, CLR_LTGRAY);
					Graphics_set_font( ptr_main_module->m_gfx, mini_bold_font );

					sprintf(word,"Speed %d",speed);
					pos=centerpos(ptr_main_module,word);
					DisplayGraphics_draw_text(ptr_main_module->m_gfx,word, pos, 90 );
					DisplayGraphics_draw_text(ptr_main_module->m_gfx,myfile, centerpos(ptr_main_module,myfile), 0 );
				}

				//

				DisplayGraphics_show(ptr_main_module->m_gfx );
				cWinApp_pause(ptr_main_module->m_process,(speed+fullstop));
			
				do{
					switch(getinput(ptr_main_module)){
						case KEY_ESC:
							ext=1;
						break;
						
						case KEY_SPACE:
							paused=1-paused;
						break;
			
						case KEY_H:
							h=1-h;
						break;

						case KEY_I:
							tmp=fc;
							fc=tc;
							tc=tmp;					
						break;
			
						case KEY_LEFT:
						case KEY_O:
							speed-=20;
							if (speed<0){speed=0;}
						break;
						
						case KEY_RIGHT:
						case KEY_P:
							speed+=20;
							if (speed>500){speed=500;}
						break;
					}
				}while(paused==1);		
			}
		}
	}else{
		TRACE("Book reader could not open %s",myfile);
	}

	free(word);
	FileInput_dtor(&file_input, LEAVE_MEMORY);
}
