/*

StormPlayer
VideoNow Decoder
by ssjx
2003

*/

#include <cybiko.h>

/* wav_chunk (8) id='wav ','data', */

struct 
{
char id[4];
long size;
}wav_chunk;

struct
{
short comp;
short channels;
long rate;
long byteps;
short block;
short bits;
char space[128];
}wav_fmt;

/**************************/

void dec_videonow(char *in,char *out){
int i,j,byt,c1,c2,c3,c4,bpos=0,pos=0;

	for(j=0;j<80;j++){
		for(i=0;i<20;i++){
			byt=in[bpos];
			c1=3-((byt & 0x000f)>>2);
			c2=3-((byt & 0x00f0)>>6);
			
			byt=in[bpos+1];    	    	
			c3=3-((byt & 0x000f)>>2);
			c4=3-((byt & 0x00f0)>>6);
			
			out[pos+i]=(c2<<6)+(c1<<4)+(c4<<2)+c3;				
			bpos+=4;
		}
		pos+=40;	
	}
}


/**************************/

long swp(long);
int bswp(int);
int getinput(struct module_t *);

/**************************/


void videonow(char *myfile,struct module_t *ptr_main_module){
	struct FileInput file_input;

	long f,datasize;
	int i,sec,vf,inp;
	char *videoframe,*scr;

	videoframe=(char *)malloc(6500); //from file
	scr=DisplayGraphics_get_page_ptr(ptr_main_module->m_gfx, 0);

	FileInput_ctor(&file_input);

	if (FileInput_open( &file_input, myfile)){
		TRACE("Loading...\n");
		FileInput_seek( &file_input, 12, SEEK_SET );

		//
		// Only looks for 2 chunks: fmt and data
		//

		Input_read( &file_input, &wav_chunk,8);
			
		if (memcmp(wav_chunk.id,"fmt ",4)==0){
			TRACE("Wave Chunk Size (%d)",swp(wav_chunk.size));
			Input_read( &file_input, &wav_fmt,swp(wav_chunk.size));
		}

		Input_read( &file_input, &wav_chunk,8);
				
		if (memcmp(wav_chunk.id,"data",4)==0){
			datasize=swp(wav_chunk.size);
			TRACE("Data size: %ld",datasize);
		}

		//
		// Clip information
		//

		if (bswp(wav_fmt.comp)==1){
			TRACE("Compression = PCM / VideoNow");
			sec=datasize/swp(wav_fmt.rate);
		}else{
			TRACE("Compression = Unknown (%d)",bswp(wav_fmt.comp));
		}

		TRACE(" ---- Info ----");
		TRACE("Compression : %d",bswp(wav_fmt.comp));
		TRACE("Channels    : %d",bswp(wav_fmt.channels));
		TRACE("Rate        : %ld",swp(wav_fmt.rate));
		TRACE("Bytes       : %ld",swp(wav_fmt.byteps));
		TRACE("Blocks      : %d",bswp(wav_fmt.block));
		TRACE("Quality     : %d bits",bswp(wav_fmt.bits));
		TRACE(" ---- Clip ----");
		TRACE("Length      : %ld seconds",sec);

		//
		// Go through the frames.
		//

		memset(scr,0,4000);

		FileInput_seek( &file_input, (2531*4), SEEK_CUR );

		for(f=0;f<sec;f++){
			for(vf=0;vf<15;vf++){
				inp=getinput(ptr_main_module);

				FileInput_seek( &file_input, 2680, SEEK_CUR );
				Input_read( &file_input, videoframe,6400);
				FileInput_seek( &file_input, 2680, SEEK_CUR );

				dec_videonow(videoframe,scr);

				DisplayGraphics_show(ptr_main_module->m_gfx );
				TRACE("Frame %d",vf);

				if(inp==KEY_ESC){break;}
			}

			if(inp==KEY_ESC){break;}
			TRACE("pos: %d/%d",f,sec);
		}
	}else{
		TRACE("Could not open file");
	}
		
	FileInput_dtor( &file_input, LEAVE_MEMORY );
	TRACE("Finished");

	free(videoframe);
}
